// MIT License
// Copyright (c) 2026 by Peter Siegmund (mars3142)
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "cartridge/parser.h"
#include "storage/storage.h"

#include <array>
#include <algorithm>
#include <filesystem>
#include <format>
#include <iostream>
#include <print>
#include <ranges>

namespace cartridge {

std::unique_ptr<Cartridge> parseData(const std::vector<uint8_t> &bytes) {
  try {
    constexpr std::array<uint8_t, 7> header = {0x02, 0x0a, 0x43, 0x41,
                                               0x52, 0x54, 0x00};
    BinaryReader reader(bytes, Endian::Little);

    if (!std::ranges::all_of(header, [&reader](const uint8_t expected) {
      return reader.getByte() == expected;
    })) {
      return nullptr;
    }

    return Cartridge::create(reader);
  } catch (...) {
    return nullptr;
  }
}

std::unique_ptr<Cartridge> parseFile(const std::string &filePath) {
  storage::Storage storage;
  auto result = storage.readFile(filePath);
  if (!result) {
    std::println(std::cerr, "Fehler beim Lesen der Datei: {}", filePath);
    return nullptr;
  }
  return parseData(*result);
}

} // namespace cartridge
